macroScript RenderLayers category:"Render Tools" tooltip:"Render Layers" 

(



--RENDER LAYERS 

--(Matte/Shadow Compositing Layer Management)

--Version 0.63a

--Started: 06/15/1999

--Edited:  03/07/2000

--Code by Borislav Petrov

--bobo@email.archlab.tuwien.ac.at

--Original Concept and Idea by Sebastian Frey

--sfrey@filmakademie.de

--and Christian Haas

--christian.haas@filmakademie.de



------------------------

--Version 0.3 

--Added support for RLA/RPF channels

--Version 0.31

--Added Random Object ID Generation

--Version 0.32

--Added Object Hide On Render Option
--Version 0.50
--Changed Rendering Code, Implemented Render Info, Cancel Rendering
--Version 0.6
--Implemented Rendering Passes
--Version 0.63
--Implemented basic Scene Snapshots
--Fixed some bugs
--Background OFF option
------------------------





global rl_nf 

local backup_array = #()

global layer_number = 0

global layer_name

global layers_roll

global lopt_roll

global gopt_roll

global rl_roll

global update_slots

global update_layer

global helper_node

global current_top_slot = 1

global current_layer

global assign_mattes 
global hide_objects

global lights_pass_array = #()
global shadow_pass_array = #()
global diffuse_pass_array = #()
global ambient_pass_array = #()
global specular_pass_array = #()
global Shadow_Pass_Geometry = #()
global Shadow_Pass_Material = #()

global Old_Background_Color 
global Old_Background_Image 
global Old_Background_State

global s_m_layers_array = #()

global s_m_material_array = #()

struct s_m_material (Node,Opacity, ReceiveShadows, ShadowAlpha, ShadowColor, Reflection, ReflectionAmount, ReflectionMap, Enabled, Hide )

struct s_m_layer (Active, Name, OutPath, OutName, OutType, FTSided, Atmos, AA, Mapping, Filter, Reflect, Shadows, IMBlur, RPass, RPshadow, RPdiffuse, RPspecular, RPambient, Background )



format "%\n" "RenderLayers: Initializing (Version 0.63) ..."





fn save_layer_in_helper l_num =

(

try

(

setAppData helper_node 990622 (layer_number as string)

current_layer = s_m_layers_array[l_num]

app_data_start = 990622+(l_num*1000000)

setAppData helper_node (app_data_start) (layer_number as string)

setAppData helper_node (app_data_start+1) (current_layer.Active as string)

setAppData helper_node (app_data_start+2) current_layer.Name

setAppData helper_node (app_data_start+3) current_layer.OutPath

setAppData helper_node (app_data_start+4) current_layer.OutName

setAppData helper_node (app_data_start+5) (current_layer.OutType as string)

setAppData helper_node (app_data_start+6) (current_layer.FTSided as string)

setAppData helper_node (app_data_start+7) (current_layer.Atmos as string)

setAppData helper_node (app_data_start+8) (current_layer.AA as string)

setAppData helper_node (app_data_start+9) (current_layer.Mapping as string)

setAppData helper_node (app_data_start+10) (current_layer.Filter as string)

setAppData helper_node (app_data_start+11) (current_layer.Reflect as string)

setAppData helper_node (app_data_start+12) (current_layer.Shadows as string)

setAppData helper_node (app_data_start+13) (current_layer.IMBlur as string)


setAppData helper_node (app_data_start+14) (current_layer.Rpass as string)
setAppData helper_node (app_data_start+15) (current_layer.RPshadow as string)
setAppData helper_node (app_data_start+16) (current_layer.RPdiffuse as string)
setAppData helper_node (app_data_start+17) (current_layer.RPspecular as string)
setAppData helper_node (app_data_start+18) (current_layer.RPambient as string)

setAppData helper_node (app_data_start+19) (current_layer.Background as string)




setAppData helper_node (990622+20) (gopt_roll.start_frame.value as string)

setAppData helper_node (990622+21) (gopt_roll.end_frame.value as string)

setAppData helper_node (990622+22) (gopt_roll.nth_frame.value as string)

setAppData helper_node (990622+23) (gopt_roll.show_vfb.checked as string)

setAppData helper_node (990622+24) (gopt_roll.save_to_disk.checked as string)

setAppData helper_node (990622+25) (gopt_roll.ignore_onoff.checked as string)



setAppData helper_node (990622+26) (gopt_roll.zdepth_channel.checked as string)

setAppData helper_node (990622+27) (gopt_roll.objectid_channel.checked as string)

setAppData helper_node (990622+28) (gopt_roll.materialid_channel.checked as string)

setAppData helper_node (990622+29) (gopt_roll.normal_channel.checked as string)



setAppData helper_node (990622+30) (gopt_roll.uvw_channel.checked as string)

setAppData helper_node (990622+31) (gopt_roll.unclamped_channel.checked as string)

setAppData helper_node (990622+32) (gopt_roll.coverage_channel.checked as string)

setAppData helper_node (990622+33) (gopt_roll.node_channel.checked as string)



setAppData helper_node (990622+34) (gopt_roll.shadercolor_channel.checked as string)

setAppData helper_node (990622+35) (gopt_roll.shadertransp_channel.checked as string)

setAppData helper_node (990622+36) (gopt_roll.velocity_channel.checked as string)

setAppData helper_node (990622+37) (gopt_roll.weight_channel.checked as string)

setAppData helper_node (990622+38) (gopt_roll.show_pb.checked as string)


setAppData helper_node (990622+39) (layers_roll.snapshot_output_path.text)




setAppData helper_node (app_data_start+(100)) (s_m_material_array.count as string)

for m = 1 to s_m_material_array.count do

(

setAppData helper_node (app_data_start+(100*m)+1) s_m_material_array[m].Node

setAppData helper_node (app_data_start+(100*m)+2) (s_m_material_array[m].Opacity as string)

setAppData helper_node (app_data_start+(100*m)+3) (s_m_material_array[m].ReceiveShadows as string)

setAppData helper_node (app_data_start+(100*m)+4) (s_m_material_array[m].ShadowAlpha as string)

setAppData helper_node (app_data_start+(100*m)+5) (s_m_material_array[m].ShadowColor as string)

setAppData helper_node (app_data_start+(100*m)+6) (s_m_material_array[m].Reflection as string)

setAppData helper_node (app_data_start+(100*m)+7) (s_m_material_array[m].ReflectionAmount as string)

setAppData helper_node (app_data_start+(100*m)+8) (s_m_material_array[m].ReflectionMap as string)

setAppData helper_node (app_data_start+(100*m)+9) (s_m_material_array[m].Enabled as string)

setAppData helper_node (app_data_start+(100*m)+10) (s_m_material_array[m].Hide as string)



)

)catch()

)





fn load_layer_from_helper l_num =

(

current_layer = s_m_layer ()

app_data_start = 990622+(l_num*1000000)

current_layer.Active = execute (getAppData helper_node  (app_data_start+1) ) 

current_layer.Name = getAppData helper_node  (app_data_start+2) 

current_layer.OutPath = getAppData helper_node  (app_data_start+3) 

current_layer.OutName = getAppData helper_node  (app_data_start+4) 

current_layer.OutType = execute (getAppData helper_node  (app_data_start+5))

current_layer.FTSided = execute (getAppData helper_node  (app_data_start+6)) 

current_layer.Atmos = execute (getAppData helper_node  (app_data_start+7) )

current_layer.AA = execute (getAppData helper_node  (app_data_start+8) )

current_layer.Mapping = execute (getAppData helper_node  (app_data_start+9) )

current_layer.Filter = execute (getAppData helper_node  (app_data_start+10) )

current_layer.Reflect = execute (getAppData helper_node  (app_data_start+11) )

current_layer.Shadows= execute (getAppData helper_node  (app_data_start+12) )

current_layer.IMBlur = execute (getAppData helper_node  (app_data_start+13) )


try
(
current_layer.Rpass = execute (getAppData helper_node (app_data_start+14) )
current_layer.RPshadow = execute (getAppData helper_node (app_data_start+15) )
current_layer.RPdiffuse = execute (getAppData helper_node (app_data_start+16) )
current_layer.RPspecular = execute ( getAppData helper_node (app_data_start+17) )
current_layer.RPambient = execute (getAppData helper_node (app_data_start+18) )
)
catch
(
current_layer.Rpass = false
current_layer.RPshadow = true
current_layer.RPdiffuse = true
current_layer.RPspecular = true
current_layer.RPambient = false
)

try
(
current_layer.Background = execute (getAppData helper_node  (app_data_start+19) )
)
catch
(
current_layer.Background =false
)


s_m_layers_array[l_num] = current_layer



gopt_roll.start_frame.value = execute (getAppData helper_node (990622+20))

gopt_roll.end_frame.value = execute (getAppData helper_node (990622+21))

gopt_roll.nth_frame.value = execute (getAppData helper_node (990622+22))

gopt_roll.show_vfb.checked = execute (getAppData helper_node (990622+23))

gopt_roll.save_to_disk.checked = execute (getAppData helper_node (990622+24))

gopt_roll.ignore_onoff.checked = execute (getAppData helper_node (990622+25))



try

(

gopt_roll.zdepth_channel.checked = execute (getAppData helper_node (990622+26))

gopt_roll.objectid_channel.checked = execute (getAppData helper_node (990622+27))

gopt_roll.materialid_channel.checked = execute (getAppData helper_node (990622+28))

gopt_roll.normal_channel.checked = execute (getAppData helper_node (990622+29))



gopt_roll.uvw_channel.checked = execute (getAppData helper_node (990622+30))

gopt_roll.unclamped_channel.checked= execute (getAppData helper_node (990622+31))

gopt_roll.coverage_channel.checked = execute (getAppData helper_node (990622+32))

gopt_roll.node_channel.checked = execute (getAppData helper_node (990622+33))



gopt_roll.shadercolor_channel.checked  = execute (getAppData helper_node (990622+34))

gopt_roll.shadertransp_channel.checked = execute (getAppData helper_node (990622+35))

gopt_roll.velocity_channel.checked = execute (getAppData helper_node (990622+36))

gopt_roll.weight_channel.checked  = execute (getAppData helper_node (990622+37))
gopt_roll.show_pb.checked = execute (getAppData helper_node (990622+38))

)

catch()

try
(
layers_roll.snapshot_output_path.text = getAppData helper_node (990622+39) 

)
catch()



mat_array_count = (getAppData helper_node (app_data_start+(100))) as integer

s_m_material_array = #()

for m = 1 to mat_array_count do

(

s_m_material_array[m] = s_m_material Node:""

s_m_material_array[m].Node = getAppData helper_node (app_data_start+(100*m)+1) 

s_m_material_array[m].Opacity = execute (getAppData helper_node (app_data_start+(100*m)+2) )

s_m_material_array[m].ReceiveShadows = execute (getAppData helper_node (app_data_start+(100*m)+3) )

s_m_material_array[m].ShadowAlpha  = execute (getAppData helper_node (app_data_start+(100*m)+4) )

s_m_material_array[m].ShadowColor = execute (getAppData helper_node (app_data_start+(100*m)+5)  ) 

s_m_material_array[m].Reflection = execute (getAppData helper_node (app_data_start+(100*m)+6) )

s_m_material_array[m].ReflectionAmount = execute (getAppData helper_node (app_data_start+(100*m)+7) )

s_m_material_array[m].ReflectionMap  = execute (getAppData helper_node (app_data_start+(100*m)+8) )

s_m_material_array[m].Enabled = execute (getAppData helper_node (app_data_start+(100*m)+9)  )

try

(

s_m_material_array[m].Hide = execute (getAppData helper_node (app_data_start+(100*m)+10)  )

)

catch

(

s_m_material_array[m].Hide = false

)

)



--print current_layer

)





fn update_local_options =

(

lopt_roll.layer_output_path.text = current_layer.OutPath

lopt_roll.layer_output_name.text = current_layer.OutName

lopt_roll.layer_output_type.selection = current_layer.OutType

lopt_roll.force_double_sided.checked = current_layer.FTSided

lopt_roll.atmospheric_yes.checked = current_layer.Atmos

lopt_roll.aa_yes.checked = current_layer.AA

lopt_roll.Mapping_yes.checked = current_layer.Mapping

lopt_roll.FilterMaps_yes.checked = current_layer.Filter

lopt_roll.Reflect_yes.checked = current_layer.Reflect

lopt_roll.Shadows_yes.checked = current_layer.Shadows

lopt_roll.IMB_yes.checked = current_layer.IMBlur
lopt_roll.Background_yes.checked = current_layer.Background


lopt_roll.render_passes.checked = current_layer.Rpass
lopt_roll.render_pass_shadow.checked = current_layer.RPshadow
lopt_roll.render_pass_diffuse.checked = current_layer.RPdiffuse
lopt_roll.render_pass_specular.checked = current_layer.RPspecular
lopt_roll.render_pass_ambient.checked = current_layer.RPambient
)



	

fn display_stats = 

(

actives_count = 0

for i in s_m_layers_array do if i.Active then actives_count += 1

layers_roll.number_of_layers.text = layers_roll.layers_list.selection as string +"/"+layer_number as string+"(" + actives_count as string + ")"

)



fn update_layer =

(

if s_m_layers_array.count > 0 then

	(

	layers_roll.preview_layer.enabled = true

	layers_roll.render_current_layer.enabled = true

	layers_roll.render_all_layers.enabled = true

	)

try (removerollout rl_roll rl_nf ) catch ()

addrollout rl_roll rl_nf  

try

(

current_layer = s_m_layers_array[layers_roll.layers_list.selection]

layers_roll.activate_layer.checked = current_layer.Active

display_stats ()

update_slots 1

update_local_options()

)

catch ()

)	







fn generate_random_objectid =

(

scene_nodes = geometry as array	

channel_index = #()				

for i in scene_nodes do			

	(

	if i.gbufferChannel != 0 then					

		(

		channel_index[i.gbufferChannel] = true	

		)

	)

format "%\n" "RenderLayers: Assigning MatIDs to Scene Object..." 	

new_id = 0											

for i in scene_nodes do								

	(

	if i.gbufferChannel == 0 then					

		(

		new_id += 1									

		while channel_index[new_id] != undefined do	

													

			(

			new_id += 1								

			)

		i.gbufferChannel = new_id					

		format "ID %: %\n" new_id i.name			

		)

	)	

format "%\n" "RenderLayers: Ready.\n" 								

)





fn select_by_object_id search_id =

(

scene_nodes = geometry as array	

select_array = #()				

for i in scene_nodes do			

	(

	if i.gbufferChannel == search_id then					

		(

		append select_array i	

		)	

	)

select select_array

format "% % % % %\n" "RenderLayers:" (select_array.count as string) "Object(s) with Object ID" (search_id as string) "Selected."



)





----------------------------------------------------------------------------------------





rollout lopt_roll "Layer Rendering Options"

(



button get_output_path "Get Path" width:50 height:17 align:#left pos:[5,5]

edittext layer_output_path text:"c:\\temp\\" width:180 align:#left pos:[55,5]

edittext layer_output_name text:"layer" width:90 align:#left pos:[235,5]

dropdownlist layer_output_type width:60 align:#left items:#(".TGA",".RLA",".PNG",".RPF") pos:[330,5]



group "Rendering Options"

(

checkbox force_double_sided "Force 2-Sided" checked:false across:3

checkbox atmospheric_yes "Atmospherics" checked:true

checkbox aa_yes "Anti-Aliasing" checked:true

checkbox Mapping_yes "Mapping" checked:true across:3

checkbox FilterMaps_yes "Filter Maps" checked:true  

checkbox Reflect_yes "Auto-Reflect" checked:true

checkbox Shadows_yes "Shadows" checked:true across:3

checkbox IMB_yes "Image MBlur" checked:true
checkbox Background_yes "Background" checked:true
)

group "Render Passes"
(
checkbox render_passes "RENDER SEPARATE PASSES" checked:false 
checkbox render_pass_shadow "Shadow Pass" checked:true across:4
checkbox render_pass_diffuse "Diffuse Pass" checked:true
checkbox render_pass_specular "Specular Pass" checked:true
checkbox render_pass_ambient "Ambient Pass" checked:false
)


on render_passes changed state do 
	(
	if layer_number > 0 then 
	(
	current_layer.Rpass = state
	save_layer_in_helper layers_roll.layers_list.selection
	)
	)
on render_pass_shadow changed state do 
	(
	if layer_number > 0 then 
	(
	current_layer.RPshadow = state
	save_layer_in_helper layers_roll.layers_list.selection
	)
	)
on render_pass_diffuse changed state do 
	(
	if layer_number > 0 then 
	(
	current_layer.RPdiffuse = state
	save_layer_in_helper layers_roll.layers_list.selection
	)
	)
on render_pass_specular changed state do 
	(
	if layer_number > 0 then 
	(
	current_layer.RPspecular = state
	save_layer_in_helper layers_roll.layers_list.selection
	)
	)
on render_pass_ambient changed state do 
	(
	if layer_number > 0 then 
	(
	current_layer.RPambient = state
	save_layer_in_helper layers_roll.layers_list.selection
	)
	)



on force_double_sided changed state do 

	(

	if layer_number > 0 then 

	(

	current_layer.FTSided = state

	save_layer_in_helper layers_roll.layers_list.selection

	)

	)

on atmospheric_yes changed state do 

	(

	if layer_number > 0 then 

	(

	current_layer.Atmos = state	

	save_layer_in_helper layers_roll.layers_list.selection

	)

	)

on aa_yes changed state do 

	(

	if layer_number > 0 then 

	(

	current_layer.AA = state	

	save_layer_in_helper layers_roll.layers_list.selection

	)

	)

on Mapping_yes changed state do 

	(

	if layer_number > 0 then 

	(

	current_layer.Mapping = state	

	save_layer_in_helper layers_roll.layers_list.selection

	)

	)

on FilterMaps_yes changed state do 

	(

	if layer_number > 0 then 

	(

	current_layer.Filter= state	

	save_layer_in_helper layers_roll.layers_list.selection

	)

	)

on Reflect_yes changed state do 

	(

	if layer_number > 0 then 

	(

	current_layer.Reflect = state	

	save_layer_in_helper layers_roll.layers_list.selection

	)

	)

on Shadows_yes changed state do 

	(

	if layer_number > 0 then 

	(

	current_layer.Shadows = state	

	save_layer_in_helper layers_roll.layers_list.selection

	)

	)

on IMB_yes changed state do 

	(

	if layer_number > 0 then 

	(

	current_layer.IMBlur = state	

	save_layer_in_helper layers_roll.layers_list.selection

	)

	)
on Background_yes changed state do 
	(
	if layer_number > 0 then 
	(
	current_layer.Background = state	
	save_layer_in_helper layers_roll.layers_list.selection
	)
	)

	

	

on layer_output_path entered txt do

(

if layer_number > 0 then 

	(

	s_m_layers_array.OutPath = txt

	save_layer_in_helper layers_roll.layers_list.selection



	)

)



on layer_output_name entered txt do

(

if layer_number > 0 then 

	(

	s_m_layers_array.OutName = txt

	save_layer_in_helper layers_roll.layers_list.selection

	)

)



on get_output_path pressed do
(
if layer_number > 0 then 
(
last_name = layer_output_name.text
new_path = getSaveFileName filename:last_name types:"Targe (*.TGA)|*.tga|RLA (*.RLA)|*.rla|Portable Network Graphics (*.PNG)|*.png|Rich Pixel Format (*.RPF)|*.rpf|All Files (*.*)|*.*|"
if new_path != undefined then 
	(
	layer_output_path.text = getfilenamepath (new_path)
	s_m_layers_array.OutPath = getfilenamepath (new_path)
	if getfilenamefile (new_path) != "" then s_m_layers_array.OutName = getfilenamefile (new_path)
	save_layer_in_helper layers_roll.layers_list.selection
	update_layer ()
	)
)	
)


on layer_output_type selected itm do

(

if layer_number > 0 then 

	(

	s_m_layers_array.OutType = itm

	save_layer_in_helper layers_roll.layers_list.selection

	)

)



)--end lopt_roll



----------------------------------------------------------------------------------------





rollout gopt_roll "Global Rendering Options"

(

group "Time Settings"

(

spinner start_frame "Start Frame:" range:[Animationrange.start,Animationrange.end,Animationrange.start] type:#integer across:3

spinner end_frame "End Frame:" range:[Animationrange.start,Animationrange.end,Animationrange.end] type:#integer

spinner nth_frame "Nth Frame:" range:[1,1000,1] type:#integer

)

group "Options"

(

checkbox show_vfb "Show VFB" checked:true across:4
checkbox show_pb "Progress Info" checked:true 
checkbox save_to_disk "Save Files" checked:true 

checkbox ignore_onoff "Ignore On/Off" checked:false

)



group "Utilities"

(

button gen_objectids "Generate Object IDs" align:#left across:3 width:140 offset:[0,-3]

button sel_by_objectids "Select By Object ID" align:#center width:140 offset:[30,-3]

spinner search_for_id "ID" range:[0,65536,0] type:#integer align:#right

)



on gen_objectids pressed do

(

generate_random_objectid ()

)



on sel_by_objectids pressed do

(

select_by_object_id search_for_id.value

)





group "RLA/RPF Optional Channels"

(

checkbox zdepth_channel "Z-Buffer" checked:false across:4

checkbox objectid_channel "Object ID" checked:true

checkbox materialid_channel "Material ID" checked:false

checkbox normal_channel "Normals" checked:false



checkbox uvw_channel "UV Coords" checked:false across:4

checkbox unclamped_channel "Unclamped" checked:false

checkbox coverage_channel "Coverage" checked:false

checkbox node_channel "Node" checked:false



checkbox shadercolor_channel "Shader Color" checked:false across:4

checkbox shadertransp_channel "Shader Transp." checked:false

checkbox velocity_channel "Velocity" checked:false

checkbox weight_channel "Weight" checked:false

)




on zdepth_channel changed state do 

	(

	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection

	)

	

on objectid_channel changed state do 

	(

	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection

	)



on materialid_channel changed state do 

	(

	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection

	)



on normal_channel changed state do 

	(

	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection

	)



on uvw_channel changed state do 

	(

	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection

	)

	

on unclamped_channel changed state do 

	(

	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection

	)



on coverage_channel changed state do 

	(

	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection

	)



on node_channel changed state do 

	(

	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection

	)

	

on shadercolor_channel changed state do 

	(

	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection

	)

	

on shadertransp_channel changed state do 

	(

	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection

	)



on velocity_channel changed state do 

	(

	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection

	)



on weight_channel changed state do 

	(

	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection

	)

	



on start_frame changed value do 

	(

	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection

	)



on end_frame changed value do 

	(

	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection

	)



on nth_frame changed value do 

	(

	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection

	)



on show_vfb changed state do 

	(

	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection

	)

on save_to_disk changed state do 

	(

	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection

	)

on ignore_onoff changed state do 

	(

	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection

	)

on show_pb changed state do 
	(
	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection
	)	


on render_passes changed state do 
	(
	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection
	)
on render_pass_shadow changed state do 
	(
	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection
	)
on render_pass_diffuse changed state do 
	(
	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection
	)
on render_pass_specular changed state do 
	(
	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection
	)
on render_pass_ambient changed state do 
	(
	if layer_number > 0 then save_layer_in_helper layers_roll.layers_list.selection
	)
	

	

)--end lopt_roll



----------------------------------------------------------------------------------------


rollout ri_roll "RenderLayers Progress Info"
(
progressbar ri_fullbar value:0 color:(color 0 0 100) width:250 height:10 align:#center 
progressbar ri_bar value:0 color:(color 255 0 0) width:250 height:10 align:#center 
label ri_label00 ""
label ri_label01 ""
label ri_label02 ""
label ri_label03 ""
label ri_label04 ""
label ri_label05 ""
label ri_label06 ""
)




rollout layers_roll "RenderLayers Setup"

(
checkbutton activate_layer "On" pos:[5,5] width:23 height:21 align:#left highlightcolor:(color 200 255 200)

label number_of_layers "0/0(0)" pos:[208,8] align:#right



button get_name_for_edit "Edit" pos:[190,49] width:50 height:17 tooltip:"Get Layer Name for Editing" align:#left

edittext edit_layer_name text:"" fieldwidth:148 pos:[238,49]



button all_active "All On" pos:[240,5] height:20 width:50 tooltip:"Activate ALL Layers"

button all_inactive "All Off " pos:[290,5] height:20 width:50 tooltip:"Deactivate ALL Layers"

button all_invert "Invert" pos:[340,5] height:20 width:50 tooltip:"Invert Activation - Turn Inactive Layers ON and Active OFF"



button create_new_layer "New" pos:[190,27] width:50 height:20 tooltip:"Create a New Layer"

button rename_current_layer "Rename" pos:[240,27] height:20 width:50 tooltip:"Rename Current Layer Using the Name in the Edit Field."

button clone_current_layer "Clone" pos:[290,27] height:20 width:50 tooltip:"Create a New Copy of the Current Layer"

button delete_current_layer "Delete" pos:[340,27] height:20 width:50 tooltip:"Delete the Current Layer"


listbox layers_list items:#() width:140 pos:[30,5] height:4





group "Rendering"

(

button preview_layer "PREVIEW" align:#center offset:[0,0] width:120 tooltip:"Render a Preview Image of the Current Layer at Current Frame" across:3 enabled:false

button render_current_layer "RENDER LAYER" align:#center offset:[2,0] width:120 tooltip:"Render Current Layer Only" enabled:false

button render_all_layers "RENDER ALL" align:#right width:120 tooltip:"Render All Layers" enabled:false

)


group "Snapshot MAX Scene"
(
button get_snapshot_path "Get Path" width:50 height:17 align:#left across:2
edittext snapshot_output_path text:"c:\\temp\\" width:330 align:#right

button snapshot_layer "SNAPSHOT LAYER" align:#left width:187 tooltip:"Snapshot a MAX Scene of the Current Layer" enabled:true across:2
button snapshot_all "SNAPSHOT ALL LAYERS" align:#right width:187 tooltip:"Snapshot MAX Scenes of ALL Layers" enabled:true

)

on get_snapshot_path pressed do
(
new_path = getSavePath()
if new_path != undefined then 
	(
	snapshot_output_path.text = new_path
	save_layer_in_helper layers_roll.layers_list.selection
	)
)




---------------------------------------------------------------------------------------------







on delete_current_layer pressed do

(

if layers_list.items.count == 1 then

	(

	q = querybox "About to DELETE the Current Layer\nfrom the Setup.\nYou CANNOT UNDO this step!\nContinue?" title:"RenderLayers - Delete Layer"

	if q then

	(

	s_m_layers_array = #()

	setAppData helper_node 990622 "0"

	layers_list.items = #()

	layers_list.selection = 0

	layer_number = 0

	removerollout rl_roll rl_nf	

	number_of_layers.text =  "0/0(0)"

	preview_layer.enabled = false

	render_current_layer.enabled = false

	render_all_layers.enabled = false

	)

	)

	

if layers_list.items.count > 1 and layers_list.selection < layers_list.items.count then

	(

	q = querybox "About to DELETE the Current Layer\nfrom the Setup.\nYou CANNOT UNDO this step!\nContinue?" title:"RenderLayers - Delete Layer"

	if q then

	(

	temp_array = layers_list.items

	for k = layers_list.selection to layers_list.items.count-1 do

		(

		load_layer_from_helper (k+1)

		s_m_layers_array[k] = s_m_layers_array[k+1]

		temp_array[k] = temp_array[k+1]

		save_layer_in_helper k

		)

	deleteItem s_m_layers_array layers_list.items.count	

	deleteItem Temp_array layers_list.items.count

	layers_list.items = temp_array

	layer_number = s_m_layers_array.count

	setAppData helper_node 990622 (layer_number as string)

	if layers_list.selection > 1 then layers_list.selection -= 1

	load_layer_from_helper layers_list.selection 

	update_layer ()

	)

	)
if layers_list.items.count > 1 and layers_list.selection == layers_list.items.count then
	(
	q = querybox "About to DELETE the Current Layer\nfrom the Setup.\nYou CANNOT UNDO this step!\nContinue?" title:"RenderLayers - Delete Layer"
	if q then
	(
	temp_array = layers_list.items
	deleteItem s_m_layers_array layers_list.items.count	
	deleteItem Temp_array layers_list.items.count
	layers_list.items = temp_array
	layer_number = s_m_layers_array.count
	setAppData helper_node 990622 (layer_number as string)
	layers_list.selection = layer_number 
	load_layer_from_helper layers_list.selection 
	update_layer ()
	)
	)	
)







on clone_current_layer pressed do

(



	

if layers_list.items.count > 0 then

	(

	temp_array = layers_list.items

	for k = layers_list.items.count to layers_list.selection  by - 1 do

		(

		load_layer_from_helper (k)

		s_m_layers_array[k+1] = s_m_layers_array[k]

		temp_array[k+1] = temp_array[k]

		save_layer_in_helper (k+1)

		)

	layers_list.items = temp_array

	layer_number = s_m_layers_array.count

	setAppData helper_node 990622 (layer_number as string)

	load_layer_from_helper layers_list.selection 

	update_layer ()

	)

)





on all_active pressed do

(

if layer_number > 0 then 

(

for k = 1 to layers_list.items.count do

	(

	s_m_layers_array[k].Active  = true

	save_layer_in_helper k

	)

	display_stats ()

	activate_layer.checked = true

)

)



on all_inactive pressed do

(

if layer_number > 0 then 

(

for k = 1 to layers_list.items.count do

	(

	s_m_layers_array[k].Active  = false

	save_layer_in_helper k

	)

	display_stats ()

	activate_layer.checked = false

)

)



on all_invert pressed do

(

if layer_number > 0 then 

(

for k = 1 to layers_list.items.count do

	(

	s_m_layers_array[k].Active  = not s_m_layers_array[k].Active

	save_layer_in_helper k

	)

	display_stats ()

	activate_layer.checked = not activate_layer.checked

)

)



on layers_list selected itm do

(

if layer_number > 0 then 

	(

	load_layer_from_helper itm

	update_layer ()

	)

)



on get_name_for_edit pressed do

(

if layer_number > 0 then 

	(

	temp_array = layers_list.items

	edit_layer_name.text = layers_list.items[layers_list.selection]

	)

)









on activate_layer changed state do

(

if layer_number > 0 then 

	(

	s_m_layers_array[layers_list.selection].Active  = state

	save_layer_in_helper layers_list.selection

	display_stats ()

	)

)



on create_new_layer pressed do

(

layer_number += 1

activate_layer.checked = true

if edit_layer_name.text == "" then 

	(

	layer_name = "Layer_"+layer_number as string

	)

	else

	(

	layer_name = edit_layer_name.text 

	)



new_layer = s_m_layer Name:layer_name active:true OutPath:lopt_roll.layer_output_path.text OutName:(layer_name+"_") OutType:1 FTSided:true Atmos:true AA:true Mapping:true Filter:true Reflect:true Shadows:true IMBlur:true RPass:false RPshadow:true RPdiffuse:true RPspecular:true RPambient:false Background:false

s_m_layers_array[layer_number] = new_layer

temp_array = layers_list.items 

append temp_array layer_name

layers_list.items = temp_array

layers_list.selection = temp_array.count

s_m_material_array = #()

save_layer_in_helper layer_number



update_layer ()

scene_nodes = for i in geometry collect i.name

rl_roll.c_box.items = scene_nodes

)





on rename_current_layer pressed do

(

if layers_list.items.count > 0 and edit_layer_name.text != "" then 

	(

	temp_array = layers_list.items

	temp_array[layers_list.selection] = edit_layer_name.text

	s_m_layers_array[layers_list.selection].Name = edit_layer_name.text

	layers_list.items = temp_array

	save_layer_in_helper layers_list.selection

	)

)







fn assign_mattes = 

(

backup_array = #()

for o = 1 to s_m_material_array.count do

(
try
(

node_from_name = execute ("$'"+s_m_material_array[o].node+"'")
)
catch(node_from_name = undefined)


if node_from_name != undefined then 

(

backup_array[o] = node_from_name.material



if s_m_material_array[o].Enabled then

	(

	new_matte = matteShadow name:("RL_Matte_"+s_m_material_array[o].Node)

	

	if s_m_material_array[o].Opacity != undefined then 

		(

		new_matte.opaqueAlpha = s_m_material_array[o].Opacity

		)

		else

		(

		new_matte.opaqueAlpha = s_m_material_array[o].false

		)

		

	if s_m_material_array[o].receiveShadows != undefined then

		(

		new_matte.receiveShadows = s_m_material_array[o].receiveShadows

		)

		else

		(

		new_matte.receiveShadows = false

		)

	if s_m_material_array[o].ShadowAlpha != undefined then

		(

		new_matte.affectAlpha = s_m_material_array[o].ShadowAlpha

		)

		else

		(

		new_matte.affectAlpha = false

		)

	if s_m_material_array[o].ShadowColor != undefined then

		(	

		new_matte.color = s_m_material_array[o].ShadowColor	

		)

		else

		(

		new_matte.color = color 0 0 0

		)

	if 	s_m_material_array[o].ReflectionAmount != undefined then

		(

		new_matte.amount = (s_m_material_array[o].ReflectionAmount.r / 255.0)*100.0

		)

		else

		(

		new_matte.amount = 0

		)

	if s_m_material_array[o].ReflectionMap != undefined then

		(		

		new_matte.map = s_m_material_array[o].ReflectionMap

		)

		else

		(

		new_matte.map = undefined

		)

	if s_m_material_array[o].Reflection != undefined then

		(	

		new_matte.useReflMap = s_m_material_array[o].Reflection

		)

		else

		(

		new_matte.useReflMap = false

		)

	node_from_name.material = new_matte

	)

)	

)--end o loop



)





fn restore_materials =

(

for o = 1 to s_m_material_array.count do

(

node_from_name = execute ("$'"+s_m_material_array[o].node+"'")

if node_from_name != undefined then node_from_name.material = backup_array[o] 

)--end o loop



)--end fn





fn hide_objects =

(

hidden_array = #()

for o = 1 to s_m_material_array.count do

(

node_from_name = execute ("$'"+s_m_material_array[o].node+"'")

if s_m_material_array[o].hide == true then hide node_from_name

append hidden_array node_from_name

)--end o loop

hidden_array

)





fn generate_channels =

(

channel_array = #()

if gopt_roll.zdepth_channel.checked then append channel_array #zdepth

if gopt_roll.objectid_channel.checked then append channel_array #ObjectID

if gopt_roll.materialid_channel.checked then append channel_array #matID

if gopt_roll.normal_channel.checked then append channel_array #normal



if gopt_roll.uvw_channel.checked then append channel_array #UVcoords

if gopt_roll.unclamped_channel.checked then append channel_array #unClamped

if gopt_roll.coverage_channel.checked then append channel_array #Coverage

if gopt_roll.node_channel.checked then append channel_array #Node



if gopt_roll.shadercolor_channel.checked then append channel_array #shaderColor

if gopt_roll.shadertransp_channel.checked then append channel_array #shaderTransparency

if gopt_roll.velocity_channel.checked then append channel_array #Velocity

if gopt_roll.weight_channel.checked then append channel_array #Weight



channel_array

)





------------------------------------------------------
--RENDER PASSES SETUP
------------------------------------------------------

fn store_light_properties =
(
lights_pass_array = Lights as array
shadow_pass_array = #()
diffuse_pass_array = #()
ambient_pass_array = #()
specular_pass_array = #()
Old_Background_Color = backgroundColor
Old_Background_Image = EnvironmentMap
Old_Background_State = UseEnvironmentMap

for l = 1 to lights_pass_array.count do
(
if classof lights_pass_array[l] != Targetobject then 
	(
	shadow_pass_array[l] = lights_pass_array[l].castshadows
	diffuse_pass_array[l] = lights_pass_array[l].affectDiffuse
	ambient_pass_array[l] = lights_pass_array[l].AmbientOnly
	specular_pass_array[l] = lights_pass_array[l].affectSpecular
	)
)
)--end fn

fn restore_light_properties =
(
backgroundColor = Old_Background_Color
EnvironmentMap = Old_Background_Image 
UseEnvironmentMap = Old_Background_State

for l = 1 to lights_pass_array.count do
(
if classof lights_pass_array[l] != TargetObject then 
	(
	lights_pass_array[l].castshadows = shadow_pass_array[l] 
	lights_pass_array[l].affectDiffuse = diffuse_pass_array[l] 
	lights_pass_array[l].AmbientOnly = ambient_pass_array[l] 
	lights_pass_array[l].affectSpecular = specular_pass_array[l] 
	)
)
)--end fn


fn set_diffuse_pass =
(
for l = 1 to lights_pass_array.count do
(
if classof lights_pass_array[l] != TargetObject then 
	(
	lights_pass_array[l].castshadows = false
	lights_pass_array[l].affectDiffuse = true
	lights_pass_array[l].AmbientOnly = false
	lights_pass_array[l].affectSpecular = false
	)
)
)--end fn

fn set_specular_pass =
(
Old_Background_Color = backgroundColor
Old_Background_Image = EnvironmentMap
Old_Background_State =UseEnvironmentMap
backgroundColor = color 0 0 0
EnvironmentMap = undefined

for l = 1 to lights_pass_array.count do
(
if classof lights_pass_array[l] != TargetObject then 
	(
	lights_pass_array[l].castshadows = false
	lights_pass_array[l].affectDiffuse = false
	lights_pass_array[l].AmbientOnly = false
	lights_pass_array[l].affectSpecular = true
	)
)
)--end fn

fn set_ambient_pass =
(
Old_Background_Color = backgroundColor
Old_Background_Image = EnvironmentMap
Old_Background_State =UseEnvironmentMap
backgroundColor = color 0 0 0
EnvironmentMap = undefined

for l = 1 to lights_pass_array.count do
(
if classof lights_pass_array[l] != TargetObject then 
	(
	lights_pass_array[l].castshadows = false
	lights_pass_array[l].affectDiffuse = false
	lights_pass_array[l].AmbientOnly = true
	lights_pass_array[l].affectSpecular = false
	)
)
)--end fn

fn set_shadow_pass =
(
Old_Background_Color = backgroundColor
Old_Background_Image = EnvironmentMap
Old_Background_State =UseEnvironmentMap
backgroundColor = color 255 255 255
EnvironmentMap = undefined
Shadow_Pass_Geometry = #()
Shadow_Pass_Material = #()
shadow_pass_matte = MatteShadow receiveShadows:true affectalpha:true shadow_brightness:0
for o in Geometry do
(
if classof o.material != MatteShadow then 
	(
	append Shadow_Pass_Geometry o
	append Shadow_Pass_Material o.material
	o.material = shadow_pass_matte
	)
)
)--end fn

fn reset_shadow_pass =
(
backgroundColor = Old_Background_Color
EnvironmentMap = Old_Background_Image 
UseEnvironmentMap = Old_Background_State

for o = 1 to Shadow_Pass_Geometry.count do
	(
	Shadow_Pass_Geometry[o].material = Shadow_Pass_Material[o]
	)
)--end fn


fn disable_background =
(
Old_Background_Color = backgroundColor
Old_Background_Image = EnvironmentMap
Old_Background_State = UseEnvironmentMap
backgroundColor = color 0 0 0
EnvironmentMap = undefined
)--end fn

fn enable_background =
(
backgroundColor = Old_Background_Color 
EnvironmentMap = Old_Background_Image 
UseEnvironmentMap = Old_Background_State
)--end fn


-----------------------------------------
--SNAPSHOT LAYERS
-----------------------------------------

on snapshot_layer pressed do
(
current_max_name = maxfilename
if current_max_name == "" then current_max_name = "Untitled.max"
saveMaxFile current_max_name 

(
r = layers_roll.layers_list.selection  
load_layer_from_helper r
if current_layer.Active or gopt_roll.ignore_onoff.checked then
(
update_layer ()	
assign_mattes ()
h_array = hide_objects ()

create_dir = makeDir layers_roll.snapshot_output_path.text

if current_layer.Rpass then
(
passes_count = 4
store_light_properties()
)
else
(
passes_count = 1
)

(
render_pass_name = "FULL"

for p = 1 to passes_count do
(
if current_layer.Rpass then
	(
	pass_go_on = false
	if current_layer.RPshadow and p == 1 then 
		(
		pass_go_on = true
		set_shadow_pass()
		render_pass_name = "SHD"
		)
	if current_layer.RPdiffuse and p == 2 then 
		(
		pass_go_on = true 
		set_diffuse_pass()
		render_pass_name = "DIF"
		if not current_layer.Background then disable_background()		
		)
	if current_layer.RPspecular and p == 3 then 
		(
		pass_go_on = true 
		set_specular_pass()
		render_pass_name = "SPC"
		)
	if current_layer.RPambient and p == 4 then 
		(
		pass_go_on = true
		set_ambient_pass()
		render_pass_name = "AMB"
		)
	)
	else
	(
	pass_go_on = true
	if not current_layer.Background then disable_background()		
	)
if pass_go_on then
(
out_file = lopt_roll.layer_output_path.text + "\\" + lopt_roll.layer_output_name.text + "_"+render_pass_name +"_" +lopt_roll.layer_output_type.items[current_layer.OutType]
rendOutputFilename = out_file 
snapshot_name = snapshot_output_path.text + "\\" + getfilenamefile current_max_name + "_" + current_layer.OutName+"_"+render_pass_name
saveMaxFile snapshot_name 

if current_layer.Rpass then 
	(
	restore_light_properties()
	if current_layer.RPshadow and p == 1 then reset_shadow_pass()
	)
	else
	(
	if not current_layer.Background then enable_background()
	)

)--end go_on
)--end p loop

)--end rt loop

try
(
unhide h_array
restore_materials ()
)
catch
(format "%\n" "RenderLayers: A Severe Error Occured. Possible Cause:Deleted Object")

)--end current_layer active
)--end r loop
loadMaxFile current_max_name 
helper_node = $RenderLayer_Helper
)--end render all





on snapshot_all pressed do
(
current_max_name = maxfilename
if current_max_name == "" then current_max_name = "Untitled.max"
saveMaxFile current_max_name 


layer_number = s_m_layers_array.count

for r = 1 to layer_number do
(
layers_roll.layers_list.selection  = r
load_layer_from_helper r
if current_layer.Active or gopt_roll.ignore_onoff.checked then
(
update_layer ()	
assign_mattes ()
h_array = hide_objects ()

create_dir = makeDir layers_roll.snapshot_output_path.text

if current_layer.Rpass then
(
passes_count = 4
store_light_properties()
)
else
(
passes_count = 1
)

(
render_pass_name = "FULL"

for p = 1 to passes_count do
(
if current_layer.Rpass then
	(
	pass_go_on = false
	if current_layer.RPshadow and p == 1 then 
		(
		pass_go_on = true
		set_shadow_pass()
		render_pass_name = "SHD"
		)
	if current_layer.RPdiffuse and p == 2 then 
		(
		pass_go_on = true 
		set_diffuse_pass()
		render_pass_name = "DIF"
		if not current_layer.Background then disable_background()		
		)
	if current_layer.RPspecular and p == 3 then 
		(
		pass_go_on = true 
		set_specular_pass()
		render_pass_name = "SPC"
		)
	if current_layer.RPambient and p == 4 then 
		(
		pass_go_on = true
		set_ambient_pass()
		render_pass_name = "AMB"
		)
	)
	else
	(
	pass_go_on = true
	if not current_layer.Background then disable_background()		
	)
if pass_go_on then
(

out_file = lopt_roll.layer_output_path.text + "\\" + lopt_roll.layer_output_name.text + "_"+render_pass_name +"_" +lopt_roll.layer_output_type.items[current_layer.OutType]
rendOutputFilename = out_file 
snapshot_name = snapshot_output_path.text + "\\" + getfilenamefile current_max_name + "_" + current_layer.OutName+"_"+render_pass_name
saveMaxFile snapshot_name 

if current_layer.Rpass then 
	(
	restore_light_properties()
	if current_layer.RPshadow and p == 1 then reset_shadow_pass()
	)
	else
	(
	if not current_layer.Background then enable_background()
	)

)--end go_on
)--end p loop

)--end rt loop

try
(
unhide h_array
restore_materials ()
)
catch
(format "%\n" "RenderLayers: A Severe Error Occured. Possible Cause:Deleted Object")

)--end current_layer active
)--end r loop
loadMaxFile current_max_name 
helper_node = $RenderLayer_Helper
)--end render all






---------------------------------------
--RENDER LAYERS
---------------------------------------











on preview_layer pressed do

(

assign_mattes ()

h_array = hide_objects ()

channels_to_render = generate_channels ()

if current_layer.Rpass then
(
passes_count = 4
store_light_properties()
)
else
(
passes_count = 1
)

for r = 1 to passes_count do
(
if current_layer.Rpass then
	(
	pass_go_on = false
	if current_layer.RPshadow and r == 1 then 
		(
		pass_go_on = true
		set_shadow_pass()
		)
	if current_layer.RPdiffuse and r == 2 then 
		(
		pass_go_on = true 
		set_diffuse_pass()
		if not current_layer.Background then disable_background()
		)
	if current_layer.RPspecular and r == 3 then 
		(
		pass_go_on = true 
		set_specular_pass()
		)
	if current_layer.RPambient and r == 4 then 
		(
		pass_go_on = true
		set_ambient_pass()
		)
	)
	else
	(
	pass_go_on = true
	if not current_layer.Background then disable_background()
	)
if pass_go_on then
(
render vfb:gopt_roll.show_vfb.checked force2sided:current_layer.FTSided renderatmosphericeffects:current_layer.Atmos autoreflect:current_layer.Reflect antiAliasing:current_layer.AA\ 

mapping:current_layer.Mapping shadows:current_layer.Shadows imageMotionBlur:current_layer.IMBlur filtermaps:current_layer.Filter channels:channels_to_render 
if current_layer.Rpass then 
	(
	restore_light_properties()
	if current_layer.RPshadow  and r == 1 then reset_shadow_pass()
	)
)--end go_on
)--end r loop

unhide h_array

restore_materials ()
if current_layer.Rpass then 
	(
	restore_light_properties()
	)
	else
	(
	if not current_layer.Background then enable_background()
	)

)

fn convert_sec_to_time sec =
(
hours = floor(sec/3600.0) as integer
minutes = floor ((sec - (hours*3600.0))/60.0) as integer
seconds = (sec - (minutes*60.0)) 
back_string = hours as string+" h. "+ minutes as string +" min. " +seconds as string+" sec. "
back_string 
)




on render_current_layer pressed do

(

if gopt_roll.show_pb.checked then 
(
try(closerolloutfloater rl_info_float)catch()
rl_info_float = newrolloutfloater "RenderLayers Progress Info" 300 230 0 100
addrollout ri_roll rl_info_float 
total_frames_so_far = 0
)



total_layer_time = 0
total_frames_to_render = (gopt_roll.end_frame.value - gopt_roll.start_frame.value)/gopt_roll.nth_frame.value


channels_to_render = generate_channels ()		

assign_mattes ()

h_array = hide_objects ()


if current_layer.Rpass then
(
passes_count = 4
store_light_properties()
)
else
(
passes_count = 1
)


	
		create_dir = makeDir lopt_roll.layer_output_path.text
		out_bmp = bitmap RenderWidth RenderHeight 




for rt = gopt_roll.start_frame.value to gopt_roll.end_frame.value by gopt_roll.nth_frame.value do
(
render_pass_name = "FULL"
start_time = timestamp()


for p = 1 to passes_count do
(
if current_layer.Rpass then
	(
	pass_go_on = false
	if current_layer.RPshadow and p == 1 then 
		(
		pass_go_on = true
		set_shadow_pass()
		render_pass_name = "SHD"
		)
	if current_layer.RPdiffuse and p == 2 then 
		(
		pass_go_on = true 
		set_diffuse_pass()
		render_pass_name = "DIF"
		if not current_layer.Background then disable_background()		
		)
	if current_layer.RPspecular and p == 3 then 
		(
		pass_go_on = true 
		set_specular_pass()
		render_pass_name = "SPC"
		)
	if current_layer.RPambient and p == 4 then 
		(
		pass_go_on = true
		set_ambient_pass()
		render_pass_name = "AMB"
		)
	)
	else
	(
	pass_go_on = true
	if not current_layer.Background then disable_background()	
	)
	
	
if pass_go_on then
(


out_bmp.filename = ("RenderLayers "+(layers_roll.layers_list.items[layers_roll.layers_list.selection])+" Frame:"+rt as string+" Pass:"+r as string )
out_file = lopt_roll.layer_output_path.text + "\\" + lopt_roll.layer_output_name.text + "_"+render_pass_name +"_" +lopt_roll.layer_output_type.items[current_layer.OutType]


if gopt_roll.show_pb.checked then 
(
ri_roll.ri_label00.text = ("Rendering Current Layer - Pass:" + render_pass_name)
ri_roll.ri_label01.text = ("Rendering: " + (layers_roll.layers_list.items[layers_roll.layers_list.selection]) + " from " + (gopt_roll.start_frame.value as string) + " to " + (gopt_roll.end_frame.value as string) + " every "+ (gopt_roll.nth_frame.value as string))
ri_roll.ri_label02.text = ("To: "+out_file)
ri_roll.ri_label03.text = ("Current Frame: "+ rt as string)
)

EscapeEnable = false
	if gopt_roll.save_to_disk.checked then

		(

		render vfb:gopt_roll.show_vfb.checked fromframe:rt toframe:(rt+1f) nthframe:2 \

force2sided:current_layer.FTSided renderatmosphericeffects:current_layer.Atmos autoreflect:current_layer.Reflect antiAliasing:current_layer.AA\ 

mapping:current_layer.Mapping shadows:current_layer.Shadows imageMotionBlur:current_layer.IMBlur filtermaps:current_layer.Filter\

outputfile:out_file  channels:channels_to_render to:out_bmp
		)

		else

		(

		render vfb:gopt_roll.show_vfb.checked  fromframe:rt toframe:rt \

force2sided:current_layer.FTSided renderatmosphericeffects:current_layer.Atmos autoreflect:current_layer.Reflect antiAliasing:current_layer.AA\ 

mapping:current_layer.Mapping shadows:current_layer.Shadows imageMotionBlur:current_layer.IMBlur filtermaps:current_layer.Filter  channels:channels_to_render\
to:out_bmp
		)
EscapeEnable = true

if current_layer.Rpass then 
	(
	restore_light_properties()
	if current_layer.RPshadow and p == 1 then reset_shadow_pass()
	)
	else
	(
	if not current_layer.Background then enable_background()
	)

	
)--end go_on
)--end p loop		
		
		
end_time = timestamp()

total_layer_time += ((end_time - start_time)/ 1000.0)
total_frames_so_far += 1

if gopt_roll.show_pb.checked then 
(
time_string = convert_sec_to_time ((end_time-start_time)/1000.0)
ri_roll.ri_label04.text = ("Last Frame Time: "+ time_string )
time_string = convert_sec_to_time (total_layer_time) 
ri_roll.ri_label05.text = ("Time So Far: "+ time_string )
time_string = convert_sec_to_time (total_layer_time/total_frames_so_far*(total_frames_to_render-total_frames_so_far+1)) 
ri_roll.ri_label06.text = ("Estimated Time To Go: "+ time_string )
ri_roll.ri_bar.value = (rt*100.0/gopt_roll.end_frame.value)  
)

		
)--end rt loop
close out_bmp		
try(closerolloutfloater rl_info_float)catch()
try
(
unhide h_array

restore_materials ()
)
catch
(format "%\n" "RenderLayers: A Severe Error Occured. Possible Cause:Deleted Object")


)



on render_all_layers pressed do

(

channels_to_render = generate_channels ()

layer_number = s_m_layers_array.count


if gopt_roll.show_pb.checked then 
(
try(closerolloutfloater rl_info_float)catch()
rl_info_float = newrolloutfloater "RenderLayers Progress Info" 300 230 0 100
addrollout ri_roll rl_info_float 
total_layer_time = 0
total_frames_so_far = 0
)


out_bmp = bitmap RenderWidth RenderHeight 

total_layer_time = 0
active_layer_number = 0

for r = 1 to layer_number do
(
layers_roll.layers_list.selection  = r
load_layer_from_helper r
if current_layer.Active or gopt_roll.ignore_onoff.checked then active_layer_number += 1
)


total_frames_to_render = active_layer_number*(gopt_roll.end_frame.value - gopt_roll.start_frame.value)/gopt_roll.nth_frame.value



for r = 1 to layer_number do

(

layers_roll.layers_list.selection  = r

load_layer_from_helper r

if current_layer.Active or gopt_roll.ignore_onoff.checked then

	(

	update_layer ()	

	

	assign_mattes ()

	h_array = hide_objects ()

	

	create_dir = makeDir lopt_roll.layer_output_path.text

if current_layer.Rpass then
(
passes_count = 4
store_light_properties()
)
else
(
passes_count = 1
)

for rt = gopt_roll.start_frame.value to gopt_roll.end_frame.value by gopt_roll.nth_frame.value do
(

start_time = timestamp()

render_pass_name = "FULL"

for p = 1 to passes_count do
(
if current_layer.Rpass then
	(
	pass_go_on = false
	if current_layer.RPshadow and p == 1 then 
		(
		pass_go_on = true
		set_shadow_pass()
		render_pass_name = "SHD"
		)
	if current_layer.RPdiffuse and p == 2 then 
		(
		pass_go_on = true 
		set_diffuse_pass()
		render_pass_name = "DIF"
		if not current_layer.Background then disable_background()		
		)
	if current_layer.RPspecular and p == 3 then 
		(
		pass_go_on = true 
		set_specular_pass()
		render_pass_name = "SPC"
		)
	if current_layer.RPambient and p == 4 then 
		(
		pass_go_on = true
		set_ambient_pass()
		render_pass_name = "AMB"
		)
	)
	else
	(
	pass_go_on = true
	if not current_layer.Background then disable_background()		
	)
if pass_go_on then
(

out_file = lopt_roll.layer_output_path.text + "\\" + lopt_roll.layer_output_name.text + "_"+render_pass_name +"_" +lopt_roll.layer_output_type.items[current_layer.OutType]


if gopt_roll.show_pb.checked then 
(
ri_roll.ri_label00.text = ("Rendering Total "+active_layer_number as string+" Layer(s) - Pass:" + render_pass_name)
ri_roll.ri_label01.text = ("Rendering: " + (layers_roll.layers_list.items[layers_roll.layers_list.selection]) + " from " + (gopt_roll.start_frame.value as string) + " to " + (gopt_roll.end_frame.value as string) + " every "+ (gopt_roll.nth_frame.value as string))
ri_roll.ri_label02.text = ("To: "+out_file)
ri_roll.ri_label03.text = ("Current Frame: "+ rt as string)
)


--out_bmp.filename = ("RenderLayers "+(layers_roll.layers_list.items[layers_roll.layers_list.selection])+" Frame:"+rt as string )

EscapeEnable = false


	if gopt_roll.save_to_disk.checked then

	(

	render vfb:gopt_roll.show_vfb.checked fromframe:rt toframe:(rt+1f) nthframe:2 \

	force2sided:current_layer.FTSided renderatmosphericeffects:current_layer.Atmos autoreflect:current_layer.Reflect antiAliasing:current_layer.AA\ 

	mapping:current_layer.Mapping shadows:current_layer.Shadows imageMotionBlur:current_layer.IMBlur filtermaps:current_layer.Filter outputfile:out_file  channels:channels_to_render\
	to:out_bmp	

	)

	else

	(

	render vfb:gopt_roll.show_vfb.checked fromframe:rt toframe:rt  \

	force2sided:current_layer.FTSided renderatmosphericeffects:current_layer.Atmos autoreflect:current_layer.Reflect antiAliasing:current_layer.AA\ 

	mapping:current_layer.Mapping shadows:current_layer.Shadows imageMotionBlur:current_layer.IMBlur filtermaps:current_layer.Filter  channels:channels_to_render \
	to:out_bmp

	)
EscapeEnable = true

if current_layer.Rpass then 
	(
	restore_light_properties()
	if current_layer.RPshadow and p == 1 then reset_shadow_pass()
	)
	else
	(
	if not current_layer.Background then enable_background()
	)

)--end go_on
)--end p loop

end_time = timestamp()

total_layer_time += ((end_time - start_time)/ 1000.0)
total_frames_so_far += 1

if gopt_roll.show_pb.checked then 
(
time_string = convert_sec_to_time ((end_time-start_time)/1000.0)
ri_roll.ri_label04.text = ("Last Frame Time: "+ time_string )
time_string = convert_sec_to_time (total_layer_time) 
ri_roll.ri_label05.text = ("Time So Far: "+ time_string )
time_string = convert_sec_to_time (total_layer_time/total_frames_so_far*(total_frames_to_render-total_frames_so_far+1)) 
ri_roll.ri_label06.text = ("Estimated Time To Go: "+ time_string )
ri_roll.ri_bar.value = (rt*100.0/gopt_roll.end_frame.value)  
ri_roll.ri_fullbar.value = ((r-1)*100.0/active_layer_number)  
)

)--end rt loop

try
(
unhide h_array

restore_materials ()
)
catch
(format "%\n" "RenderLayers: A Severe Error Occured. Possible Cause:Deleted Object")


)--end current_layer active

)--end r loop
close out_bmp		
try(closerolloutfloater rl_info_float)catch()

)--end render all



)--end rollout








rollout rl_roll "Current Layer Settings"
(
label title01 "Matte/Shadow" pos:[30,10] 
button title02 "O" pos:[115,10] width:14 height:14 tooltip:"Opaque Alpha"
button title03 "S" pos:[130,10] width:14 height:14 tooltip:"Receive Shadows"
button title04 "A" pos:[145,10] width:14 height:14 tooltip:"Shadow Affect Alpha"
button title05 "C" pos:[160,10] width:14 height:14 tooltip:"Shadow Color"
button title06 "R" pos:[175,10] width:14 height:14 tooltip:"Reflection"
button title07 "ra" pos:[190,10] width:14 height:14 tooltip:"Reflection Amount"
button title08 "M" pos:[204,10] enabled:false width:14 height:14 tooltip:"Reflection Map (Not Implemented Yet)"
button title10 "H" pos:[220,10] width:14 height:14 tooltip:"Hide At Rendertime"
button title09 "x" pos:[235,10] width:14 height:14 tooltip:"Remove Object From Layer"
button title11 "+" pos:[250,10] width:14 height:14 tooltip:"Active/Inactive" 
checkbox alphabetical_vis "ABC..." pos:[350,10] width:50 height:14 
label title12 "Visible" pos:[300,10] 
combobox c_box pos:[295,30] width:105 height:10 
button move_up "^" pos:[2,30] width:10 
button move_down "v" pos:[2,157] width:10
button assign_to_list "<" height:60 width:16 pos:[275,70] tooltip:"Move Selected Node to Matte/Shadow Layer"

on move_up pressed do
(
if current_top_slot > 1 then current_top_slot -= 1 
update_slots current_top_slot 
)

on move_down pressed do
(
current_top_slot += 1 
update_slots current_top_slot 
)

edittext node_name_1 ""  pos:[10,27] width:100
checkbutton opac_alpha_1 ""  pos:[115,27] width:14 height:14 highlightcolor:(color 0 255 0)
checkbutton rec_shadows_1 "" pos:[130,27] width:14 height:14 highlightcolor:(color 0 255 0)
checkbutton shad_alpha_1 "" pos:[145,27] width:14 height:14 highlightcolor:(color 0 255 0)
colorpicker shad_color_1 "" pos:[156,28] width:16 height:13 color:[0,0,0]
checkbutton ref_toggle_1  "" pos:[175,27] width:14 height:14  highlightcolor:(color 0 255 0)
colorpicker ref_amount_1 "" pos:[186,28] width:16 height:13 color:[0,0,0]
mapbutton ref_map_1 "-" pos:[204,27] width:14 height:14
checkbutton hide_toggle_1  "" pos:[220,27] width:14 height:14  highlightcolor:(color 255 255 0)
button delete_slot_1  ">" pos:[235,27] width:14 height:14
checkbox onoff_toggle_1 pos:[250,27] checked:true

on opac_alpha_1 changed state do 
	(
	try(s_m_material_array[current_top_slot].opacity = state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on rec_shadows_1 changed state do 
	(
	try(s_m_material_array[current_top_slot].receiveShadows = state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on shad_alpha_1 changed state do 
	(
	try(s_m_material_array[current_top_slot].ShadowAlpha= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on shad_color_1 changed color do 
	(
	try(s_m_material_array[current_top_slot].ShadowColor = color)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_toggle_1 changed state do 
	(
	try(s_m_material_array[current_top_slot].Reflection= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_amount_1 changed color do 
	(
	try(s_m_material_array[current_top_slot].ReflectionAmount = color)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_map_1 picked texmap do 
	(
	try(
	s_m_material_array[current_top_slot].ReflectionMap = texmap 
	if texmap == undefined then ref_map_1.text = "-" else ref_map_1.text = "M"
	)catch()
	)
on onoff_toggle_1 changed state do 
	(
	try(s_m_material_array[current_top_slot].Enabled= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on hide_toggle_1 changed state do 
	(
	try(s_m_material_array[current_top_slot].Hide= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)

edittext node_name_2 ""  pos:[10,44] width:100
checkbutton opac_alpha_2 ""  pos:[115,44] width:14 height:14 highlightcolor:(color 0 255 0)
checkbutton rec_shadows_2 "" pos:[130,44] width:14 height:14 highlightcolor:(color 0 255 0)
checkbutton shad_alpha_2 "" pos:[145,44] width:14 height:14 highlightcolor:(color 0 255 0)
colorpicker shad_color_2 "" pos:[156,45] width:16 height:13 color:[0,0,0]
checkbutton ref_toggle_2  "" pos:[175,44] width:14 height:14 highlightcolor:(color 0 255 0)
colorpicker ref_amount_2 "" pos:[186,45] width:16 height:13 color:[0,0,0]
mapbutton ref_map_2 "-" pos:[204,44] width:14 height:14
checkbutton hide_toggle_2  "" pos:[220,44] width:14 height:14  highlightcolor:(color 255 255 0)
button delete_slot_2  ">" pos:[235,44] width:14 height:14
checkbox onoff_toggle_2 pos:[250,44] checked:true

on opac_alpha_2 changed state do 
	(
	try(s_m_material_array[current_top_slot+1].opacity = state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on rec_shadows_2 changed state do 
	(
	try(s_m_material_array[current_top_slot+1].receiveShadows = state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on shad_alpha_2 changed state do 
	(
	try(s_m_material_array[current_top_slot+1].ShadowAlpha= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on shad_color_2 changed color do 
	(
	try(s_m_material_array[current_top_slot+1].ShadowColor = color)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_toggle_2 changed state do 
	(
	try(s_m_material_array[current_top_slot+1].Reflection= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_amount_2 changed color do 
	(
	try(s_m_material_array[current_top_slot+1].ReflectionAmount = color)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_map_2 picked texmap do 
	(
	try(
	s_m_material_array[current_top_slot+1].ReflectionMap = texmap 
	if texmap == undefined then ref_map_2.text = "-" else ref_map_2.text = "M"
	)catch()
	)
on onoff_toggle_2 changed state do 
	(
	try(s_m_material_array[current_top_slot+1].Enabled= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on hide_toggle_2 changed state do 
	(
	try(s_m_material_array[current_top_slot+1].Hide= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)

edittext node_name_3 ""  pos:[10,61] width:100
checkbutton opac_alpha_3 ""  pos:[115,61] width:14 height:14 highlightcolor:(color 0 255 0)
checkbutton rec_shadows_3 "" pos:[130,61] width:14 height:14 highlightcolor:(color 0 255 0)
checkbutton shad_alpha_3 "" pos:[145,61] width:14 height:14 highlightcolor:(color 0 255 0)
colorpicker shad_color_3 "" pos:[156,62] width:16 height:13 color:[0,0,0]
checkbutton ref_toggle_3  "" pos:[175,61] width:14 height:14  highlightcolor:(color 0 255 0)
colorpicker ref_amount_3 "" pos:[186,62] width:16 height:13 color:[0,0,0]
mapbutton ref_map_3 "-" pos:[204,61] width:14 height:14
checkbutton hide_toggle_3  "" pos:[220,61] width:14 height:14  highlightcolor:(color 255 255 0)
button delete_slot_3  ">" pos:[235,61] width:14 height:14
checkbox onoff_toggle_3 pos:[250,61] checked:true

on opac_alpha_3 changed state do 
	(
	try(s_m_material_array[current_top_slot+2].opacity = state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on rec_shadows_3 changed state do 
	(
	try(s_m_material_array[current_top_slot+2].receiveShadows = state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on shad_alpha_3 changed state do 
	(
	try(s_m_material_array[current_top_slot+2].ShadowAlpha= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on shad_color_3 changed color do 
	(
	try(s_m_material_array[current_top_slot+2].ShadowColor = color)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_toggle_3 changed state do 
	(
	try(s_m_material_array[current_top_slot+2].Reflection= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_amount_3 changed color do 
	(
	try(s_m_material_array[current_top_slot+2].ReflectionAmount = color)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_map_3 picked texmap do 
	(
	try(
	s_m_material_array[current_top_slot+2].ReflectionMap = texmap 
	if texmap == undefined then ref_map_3.text = "-" else ref_map_3.text = "M"
	)catch()
	)
on onoff_toggle_3 changed state do 
	(
	try(s_m_material_array[current_top_slot+2].Enabled= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on hide_toggle_3 changed state do 
	(
	try(s_m_material_array[current_top_slot+2].Hide= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)

edittext node_name_4 ""  pos:[10,78] width:100
checkbutton opac_alpha_4 ""  pos:[115,78] width:14 height:14 highlightcolor:(color 0 255 0)
checkbutton rec_shadows_4 "" pos:[130,78] width:14 height:14 highlightcolor:(color 0 255 0)
checkbutton shad_alpha_4 "" pos:[145,78] width:14 height:14 highlightcolor:(color 0 255 0)
colorpicker shad_color_4 "" pos:[156,79] width:16 height:13 color:[0,0,0]
checkbutton ref_toggle_4  "" pos:[175,78] width:14 height:14 highlightcolor:(color 0 255 0)
colorpicker ref_amount_4 "" pos:[186,79] width:16 height:13 color:[0,0,0]
mapbutton ref_map_4 "-" pos:[204,78] width:14 height:14
checkbutton hide_toggle_4  "" pos:[220,78] width:14 height:14  highlightcolor:(color 255 255 0)
button delete_slot_4  ">" pos:[235,78] width:14 height:14
checkbox onoff_toggle_4 pos:[250,78] checked:true


on opac_alpha_4 changed state do 
	(
	try(s_m_material_array[current_top_slot+3].opacity = state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on rec_shadows_4 changed state do 
	(
	try(s_m_material_array[current_top_slot+3].receiveShadows = state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on shad_alpha_4 changed state do 
	(
	try(s_m_material_array[current_top_slot+3].ShadowAlpha= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on shad_color_4 changed color do 
	(
	try(s_m_material_array[current_top_slot+3].ShadowColor = color)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_toggle_4 changed state do 
	(
	try(s_m_material_array[current_top_slot+3].Reflection= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_amount_4 changed color do 
	(
	try(s_m_material_array[current_top_slot+3].ReflectionAmount = color)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_map_4 picked texmap do 
	(
	try(
	s_m_material_array[current_top_slot+3].ReflectionMap = texmap 
	if texmap == undefined then ref_map_4.text = "-" else ref_map_4.text = "M"
	)catch()
	)
on onoff_toggle_4 changed state do 
	(
	try(s_m_material_array[current_top_slot+3].Enabled= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on hide_toggle_4 changed state do 
	(
	try(s_m_material_array[current_top_slot+3].Hide= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)

edittext node_name_5 ""  pos:[10,95] width:100
checkbutton opac_alpha_5 ""  pos:[115,95] width:14 height:14 highlightcolor:(color 0 255 0)
checkbutton rec_shadows_5 "" pos:[130,95] width:14 height:14 highlightcolor:(color 0 255 0)
checkbutton shad_alpha_5 "" pos:[145,95] width:14 height:14 highlightcolor:(color 0 255 0)
colorpicker shad_color_5 "" pos:[156,96] width:16 height:13 color:[0,0,0]
checkbutton ref_toggle_5  "" pos:[175,95] width:14 height:14 highlightcolor:(color 0 255 0)
colorpicker ref_amount_5 "" pos:[186,96] width:16 height:13 color:[0,0,0]
mapbutton ref_map_5 "-" pos:[204,95] width:14 height:14
checkbutton hide_toggle_5  "" pos:[220,95] width:14 height:14  highlightcolor:(color 255 255 0)
button delete_slot_5  ">" pos:[235,95] width:14 height:14
checkbox onoff_toggle_5 pos:[250,95] checked:true

on opac_alpha_5 changed state do 
	(
	try(s_m_material_array[current_top_slot+4].opacity = state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on rec_shadows_5 changed state do 
	(
	try(s_m_material_array[current_top_slot+4].receiveShadows = state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on shad_alpha_5 changed state do 
	(
	try(s_m_material_array[current_top_slot+4].ShadowAlpha= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on shad_color_5 changed color do 
	(
	try(s_m_material_array[current_top_slot+4].ShadowColor = color)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_toggle_5 changed state do 
	(
	try(s_m_material_array[current_top_slot+4].Reflection= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_amount_5 changed color do 
	(
	try(s_m_material_array[current_top_slot+4].ReflectionAmount = color)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_map_5 picked texmap do 
	(
	try(
	s_m_material_array[current_top_slot+4].ReflectionMap = texmap 
	if texmap == undefined then ref_map_5.text = "-" else ref_map_5.text = "M"
	)catch()
	)
on onoff_toggle_5 changed state do 
	(
	try(s_m_material_array[current_top_slot+4].Enabled= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on hide_toggle_5 changed state do 
	(
	try(s_m_material_array[current_top_slot+4].Hide= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)	
 
edittext node_name_6 ""  pos:[10,112] width:100
checkbutton opac_alpha_6 ""  pos:[115,112] width:14 height:14 highlightcolor:(color 0 255 0)
checkbutton rec_shadows_6 "" pos:[130,112] width:14 height:14 highlightcolor:(color 0 255 0)
checkbutton shad_alpha_6 "" pos:[145,112] width:14 height:14 highlightcolor:(color 0 255 0)
colorpicker shad_color_6 "" pos:[156,113] width:16 height:13 color:[0,0,0]
checkbutton ref_toggle_6  "" pos:[175,112] width:14 height:14  highlightcolor:(color 0 255 0)
colorpicker ref_amount_6 "" pos:[186,113] width:16 height:13 color:[0,0,0]
mapbutton ref_map_6 "-" pos:[204,112] width:14 height:14
checkbutton hide_toggle_6  "" pos:[220,112] width:14 height:14  highlightcolor:(color 255 255 0)
button delete_slot_6  ">" pos:[235,112] width:14 height:14
checkbox onoff_toggle_6 pos:[250,112] checked:true

on opac_alpha_6 changed state do 
	(
	try(s_m_material_array[current_top_slot+5].opacity = state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on rec_shadows_6 changed state do 
	(
	try(s_m_material_array[current_top_slot+5].receiveShadows = state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on shad_alpha_6 changed state do 
	(
	try(s_m_material_array[current_top_slot+5].ShadowAlpha= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on shad_color_6 changed color do 
	(
	try(s_m_material_array[current_top_slot+5].ShadowColor = color)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_toggle_6 changed state do 
	(
	try(s_m_material_array[current_top_slot+5].Reflection= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_amount_6 changed color do 
	(
	try(s_m_material_array[current_top_slot+5].ReflectionAmount = color)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_map_6 picked texmap do 
	(
	try(
	s_m_material_array[current_top_slot+5].ReflectionMap = texmap 
	if texmap == undefined then ref_map_6.text = "-" else ref_map_6.text = "M"
	)catch()
	)
on onoff_toggle_6 changed state do 
	(
	try(s_m_material_array[current_top_slot+5].Enabled= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on hide_toggle_6 changed state do 
	(
	try(s_m_material_array[current_top_slot+5].Hide= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)

edittext node_name_7 ""  pos:[10,129] width:100
checkbutton opac_alpha_7 ""  pos:[115,129] width:14 height:14 highlightcolor:(color 0 255 0)
checkbutton rec_shadows_7 "" pos:[130,129] width:14 height:14 highlightcolor:(color 0 255 0)
checkbutton shad_alpha_7 "" pos:[145,129] width:14 height:14 highlightcolor:(color 0 255 0)
colorpicker shad_color_7 "" pos:[156,130] width:16 height:13 color:[0,0,0]
checkbutton ref_toggle_7  "" pos:[175,129] width:14 height:14 highlightcolor:(color 0 255 0)
colorpicker ref_amount_7 "" pos:[186,130] width:16 height:13 color:[0,0,0]
mapbutton ref_map_7 "-" pos:[204,129] width:14 height:14
checkbutton hide_toggle_7  "" pos:[220,129] width:14 height:14  highlightcolor:(color 255 255 0)
button delete_slot_7  ">" pos:[235,129] width:14 height:14
checkbox onoff_toggle_7 pos:[250,129] checked:true

on opac_alpha_7 changed state do 
	(
	try(s_m_material_array[current_top_slot+6].opacity = state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on rec_shadows_7 changed state do 
	(
	try(s_m_material_array[current_top_slot+6].receiveShadows = state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on shad_alpha_7 changed state do 
	(
	try(s_m_material_array[current_top_slot+6].ShadowAlpha= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on shad_color_7 changed color do 
	(
	try(s_m_material_array[current_top_slot+6].ShadowColor = color)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_toggle_7 changed state do 
	(
	try(s_m_material_array[current_top_slot+6].Reflection= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_amount_7 changed color do 
	(
	try(s_m_material_array[current_top_slot+6].ReflectionAmount = color)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_map_7 picked texmap do 
	(
	try(
	s_m_material_array[current_top_slot+6].ReflectionMap = texmap 
	if texmap == undefined then ref_map_7.text = "-" else ref_map_7.text = "M"
	)catch()
	)
on onoff_toggle_7 changed state do 
	(
	try(s_m_material_array[current_top_slot+6].Enabled= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on hide_toggle_7 changed state do 
	(
	try(s_m_material_array[current_top_slot+6].Hide= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)


edittext node_name_8 ""  pos:[10,146] width:100
checkbutton opac_alpha_8 ""  pos:[115,146] width:14 height:14 highlightcolor:(color 0 255 0)
checkbutton rec_shadows_8 "" pos:[130,146] width:14 height:14 highlightcolor:(color 0 255 0)
checkbutton shad_alpha_8 "" pos:[145,146] width:14 height:14 highlightcolor:(color 0 255 0)
colorpicker shad_color_8 "" pos:[156,147] width:16 height:13 color:[0,0,0]
checkbutton ref_toggle_8  "" pos:[175,146] width:14 height:14 highlightcolor:(color 0 255 0)
colorpicker ref_amount_8 "" pos:[186,147] width:16 height:13 color:[0,0,0]
mapbutton ref_map_8 "-" pos:[204,146] width:14 height:14
checkbutton hide_toggle_8  "" pos:[220,146] width:14 height:14  highlightcolor:(color 255 255 0)
button delete_slot_8  ">" pos:[235,146] width:14 height:14
checkbox onoff_toggle_8 pos:[250,146] checked:true

on opac_alpha_8 changed state do 
	(
	try(s_m_material_array[current_top_slot+7].opacity = state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on rec_shadows_8 changed state do 
	(
	try(s_m_material_array[current_top_slot+7].receiveShadows = state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on shad_alpha_8 changed state do 
	(
	try(s_m_material_array[current_top_slot+7].ShadowAlpha= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on shad_color_8 changed color do 
	(
	try(s_m_material_array[current_top_slot+7].ShadowColor = color)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_toggle_8 changed state do 
	(
	try(s_m_material_array[current_top_slot+7].Reflection= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_amount_8 changed color do 
	(
	try(s_m_material_array[current_top_slot+7].ReflectionAmount = color)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_map_8 picked texmap do 
	(
	try(
	s_m_material_array[current_top_slot+7].ReflectionMap = texmap 
	if texmap == undefined then ref_map_8.text = "-" else ref_map_8.text = "M"
	)catch()
	)
on onoff_toggle_8 changed state do 
	(
	try(s_m_material_array[current_top_slot+7].Enabled= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on hide_toggle_8 changed state do 
	(
	try(s_m_material_array[current_top_slot+7].Hide= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)

edittext node_name_9 ""  pos:[10,163] width:100
checkbutton opac_alpha_9 ""  pos:[115,163] width:14 height:14 highlightcolor:(color 0 255 0)
checkbutton rec_shadows_9 "" pos:[130,163] width:14 height:14 highlightcolor:(color 0 255 0)
checkbutton shad_alpha_9 "" pos:[145,163] width:14 height:14 highlightcolor:(color 0 255 0)
colorpicker shad_color_9 "" pos:[156,164] width:16 height:13 color:[0,0,0]
checkbutton ref_toggle_9  "" pos:[175,163] width:14 height:14 highlightcolor:(color 0 255 0)
colorpicker ref_amount_9 "" pos:[186,164] width:16 height:13 color:[0,0,0]
mapbutton ref_map_9 "-" pos:[204,163] width:14 height:14
checkbutton hide_toggle_9  "" pos:[220,163] width:14 height:14  highlightcolor:(color 255 255 0)
button delete_slot_9  ">" pos:[235,163] width:14 height:14
checkbox onoff_toggle_9 pos:[250,163] checked:true

on opac_alpha_9 changed state do 
	(
	try(s_m_material_array[current_top_slot+8].opacity = state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on rec_shadows_9 changed state do 
	(
	try(s_m_material_array[current_top_slot+8].receiveShadows = state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on shad_alpha_9 changed state do 
	(
	try(s_m_material_array[current_top_slot+8].ShadowAlpha= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on shad_color_9 changed color do 
	(
	try(s_m_material_array[current_top_slot+8].ShadowColor = color)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_toggle_9 changed state do 
	(
	try(s_m_material_array[current_top_slot+8].Reflection= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_amount_9 changed color do 
	(
	try(s_m_material_array[current_top_slot+8].ReflectionAmount = color)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on ref_map_9 picked texmap do 
	(
	try(
	s_m_material_array[current_top_slot+8].ReflectionMap = texmap 
	if texmap == undefined then ref_map_9.text = "-" else ref_map_9.text = "M"
	)catch()
	)
on onoff_toggle_9 changed state do 
	(
	try(s_m_material_array[current_top_slot+8].Enabled= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)
on hide_toggle_9 changed state do 
	(
	try(s_m_material_array[current_top_slot+8].Hide= state)catch()
	save_layer_in_helper layers_roll.layers_list.selection
	)


button allon_opac_alpha "+"  pos:[115,182] width:14 height:14 
button allon_rec_shadows "+" pos:[130,182] width:14 height:14 
button allon_shad_alpha "+" pos:[145,182] width:14 height:14 
button allon_shad_color "w" pos:[160,182] width:14 height:14 
button allon_ref_toggle "+" pos:[175,182] width:14 height:14 
button allon_ref_amount "w" pos:[190,182] width:14 height:14 
button allon_hide "+" pos:[220,182] width:14 height:14 
button allon_onoff "+" pos:[250,182] width:14 height:14 

button alloff_opac_alpha "-" pos:[115,198] width:14 height:14 
button alloff_rec_shadows "-" pos:[130,198] width:14 height:14 
button alloff_shad_alpha "-" pos:[145,198] width:14 height:14 
button alloff_shad_color "b" pos:[160,198] width:14 height:14 
button alloff_ref_toggle "-" pos:[175,198] width:14 height:14 
button alloff_ref_amount "b" pos:[190,198] width:14 height:14 
button alloff_ref_map "-" pos:[205,198] width:14 height:14 
button alloff_hide "-" pos:[220,198] width:14 height:14 
button alloff_onoff "-" pos:[250,198] width:14 height:14 

button allinv_opac_alpha "i" pos:[115,214] width:14 height:14 
button allinv_rec_shadows "i" pos:[130,214] width:14 height:14 
button allinv_shad_alpha "i" pos:[145,214] width:14 height:14 
button allinv_shad_color "i" pos:[160,214] width:14 height:14 
button allinv_ref_toggle "i" pos:[175,214] width:14 height:14
button allinv_ref_amount "i" pos:[190,214] width:14 height:14 
button allinv_hide  "i" pos:[220,214] width:14 height:14 
button allinv_onoff  "i" pos:[250,214] width:14 height:14 

button clear_ms_list "Reset Layer" pos:[15,198] width:95 height:14 tooltip:"Move All Layer Objects back to Visible List."
button select_all_ms "Select In Scene"  pos:[15,182] width:95 height:14 tooltip:"Select all Layer Objects in the Scene."
button get_unselected "Get Unselelcted"  pos:[15,214] width:95 height:14 tooltip:"Get all Unselected Objects from the Scene into Layer."
button get_scene_selected "Get Selected"  pos:[15,230] width:95 height:14 tooltip:"Get all Selected Objects from the Scene into Layer."


button put_all_in_list "All To Layer"  pos:[295,198] width:105 height:14 tooltip:"Put All Visible Objects to Layer."
button select_all_visible "Select In Scene" pos:[295,214] width:105 height:14 tooltip:"Select all Visible Objects in the Scene."
button move_list_unsel "Put Unsel. To Layer" pos:[295,182] width:105 height:14 tooltip:"Put all Unselected Objects from the List to Layer."



on alphabetical_vis changed state do
(
update_slots current_top_slot
)


on allon_onoff pressed do
(
for j in s_m_material_array do j.Enabled = true
update_slots current_top_slot
)
on alloff_onoff pressed do
(
for j in s_m_material_array do j.Enabled = false
update_slots current_top_slot
)
on allinv_onoff pressed do
(
for j in s_m_material_array do j.Enabled = not j.Enabled
update_slots current_top_slot
)

on allon_opac_alpha pressed do
(
for j in s_m_material_array do j.Opacity = true
update_slots current_top_slot
)
on alloff_opac_alpha pressed do
(
for j in s_m_material_array do j.Opacity = false
update_slots current_top_slot
)
on allinv_opac_alpha pressed do
(
for j in s_m_material_array do j.Opacity = not j.Opacity
update_slots current_top_slot
)

on allon_opac_alpha pressed do
(
for j in s_m_material_array do j.Opacity = true
update_slots current_top_slot
)
on alloff_opac_alpha pressed do
(
for j in s_m_material_array do j.Opacity = false
update_slots current_top_slot
)
on allinv_opac_alpha pressed do
(
for j in s_m_material_array do j.Opacity = not j.Opacity
update_slots current_top_slot
)


on allon_rec_shadows pressed do
(
for j in s_m_material_array do j.ReceiveShadows = true
update_slots current_top_slot
)
on alloff_rec_shadows pressed do
(
for j in s_m_material_array do j.ReceiveShadows = false
update_slots current_top_slot
)
on allinv_rec_shadows pressed do
(
for j in s_m_material_array do j.ReceiveShadows = not j.ReceiveShadows
update_slots current_top_slot
)

on allon_shad_alpha pressed do
(
for j in s_m_material_array do j.ShadowAlpha = true
update_slots current_top_slot
)
on alloff_shad_alpha pressed do
(
for j in s_m_material_array do j.ShadowAlpha = false
update_slots current_top_slot
)
on allinv_shad_alpha pressed do
(
for j in s_m_material_array do j.ShadowAlpha = not j.ShadowAlpha
update_slots current_top_slot
)


on allon_shad_color pressed do
(
for j in s_m_material_array do j.ShadowColor = color 255 255 255
update_slots current_top_slot
)
on alloff_shad_color pressed do
(
for j in s_m_material_array do j.ShadowColor = color 0 0 0
update_slots current_top_slot
)
on allinv_shad_color pressed do
(
for j in s_m_material_array do j.ShadowColor = (color 255 255 255) - j.ShadowColor
update_slots current_top_slot
)

on allon_ref_toggle pressed do
(
for j in s_m_material_array do j.Reflection = true
update_slots current_top_slot
)
on alloff_ref_toggle pressed do
(
for j in s_m_material_array do j.Reflection = false
update_slots current_top_slot
)
on allinv_ref_toggle pressed do
(
for j in s_m_material_array do j.Reflection= not j.Reflection
update_slots current_top_slot
)

on allon_ref_amount pressed do
(
for j in s_m_material_array do j.ReflectionAmount = color 255 255 255
update_slots current_top_slot
)
on alloff_ref_amount pressed do
(
for j in s_m_material_array do j.ReflectionAmount = color 0 0 0
update_slots current_top_slot
)
on allinv_ref_amount pressed do
(
for j in s_m_material_array do j.ReflectionAmount = (color 255 255 255) - j.ReflectionAmount
update_slots current_top_slot
)


on allon_hide pressed do
(
for j in s_m_material_array do j.Hide = true
update_slots current_top_slot
)
on alloff_hide pressed do
(
for j in s_m_material_array do j.Hide = false
update_slots current_top_slot
)
on allinv_hide pressed do
(
for j in s_m_material_array do j.Hide = not j.Hide
update_slots current_top_slot
)


on delete_slot_1 pressed do
(
if current_top_slot <= s_m_material_array.count then 
	(
	deleteItem s_m_material_array current_top_slot
	update_slots current_top_slot
	save_layer_in_helper layers_roll.layers_list.selection
	)
)

on delete_slot_2 pressed do
(
if current_top_slot+1 <= s_m_material_array.count then 
	(
	deleteItem s_m_material_array (current_top_slot+1)
	update_slots current_top_slot
	save_layer_in_helper layers_roll.layers_list.selection
	)
)

on delete_slot_3 pressed do
(
if current_top_slot+2 <= s_m_material_array.count then 
	(
	deleteItem s_m_material_array (current_top_slot+2)
	update_slots current_top_slot
	save_layer_in_helper layers_roll.layers_list.selection
	)
)

on delete_slot_4 pressed do
(
if current_top_slot+3 <= s_m_material_array.count then 
	(
	deleteItem s_m_material_array (current_top_slot+3)
	update_slots current_top_slot
	save_layer_in_helper layers_roll.layers_list.selection
	)
)

on delete_slot_5 pressed do
(
if current_top_slot+4 <= s_m_material_array.count then 
	(
	deleteItem s_m_material_array (current_top_slot+4)
	update_slots current_top_slot
	save_layer_in_helper layers_roll.layers_list.selection
	)
)

on delete_slot_6 pressed do
(
if current_top_slot+5 <= s_m_material_array.count then 
	(
	deleteItem s_m_material_array (current_top_slot+5)
	update_slots current_top_slot
	save_layer_in_helper layers_roll.layers_list.selection
	)
)

on delete_slot_7 pressed do
(
if current_top_slot+6 <= s_m_material_array.count then 
	(
	deleteItem s_m_material_array (current_top_slot+6)
	update_slots current_top_slot
	save_layer_in_helper layers_roll.layers_list.selection
	)
)

on delete_slot_8 pressed do
(
if current_top_slot+7 <= s_m_material_array.count then 
	(
	deleteItem s_m_material_array (current_top_slot+7)
	update_slots current_top_slot
	save_layer_in_helper layers_roll.layers_list.selection
	)
)

on delete_slot_9 pressed do
(
if current_top_slot+8 <= s_m_material_array.count then 
	(
	deleteItem s_m_material_array (current_top_slot+8)
	update_slots current_top_slot
	save_layer_in_helper layers_roll.layers_list.selection
	)
)

on c_box changed str do
(
temp_array = c_box.items
for j = 1 to temp_array.count do
	(
	print (findstring temp_array[j] c_box.text)
	if substring temp_array[j] 1 c_box.text.count == c_box.text then 
		(
		c_box.selection = j
		exit
		)
	)

)

on c_box doubleclicked itm do	
(
append s_m_material_array (s_m_material Node:c_box.items[itm] opacity:false receiveShadows:false ShadowAlpha:false ShadowColor:(color 0 0 0) Reflection:false ReflectionAmount:(color 0 0 0) ReflectionMap:undefined Enabled:true Hide:false)
update_slots current_top_slot
save_layer_in_helper layers_roll.layers_list.selection
)

on assign_to_list pressed do	
(
if c_box.items.count > 0 then
(
append s_m_material_array (s_m_material Node:c_box.items[c_box.selection] opacity:false receiveShadows:false ShadowAlpha:false ShadowColor:(color 0 0 0) Reflection:false ReflectionAmount:(color 0 0 0) ReflectionMap:undefined Enabled:true Hide:false)
update_slots current_top_slot
save_layer_in_helper layers_roll.layers_list.selection
)
)

on put_all_in_list pressed do
(
for j = 1 to c_box.items.count do
(
append s_m_material_array (s_m_material Node:c_box.items[j] opacity:false receiveShadows:false ShadowAlpha:false ShadowColor:(color 0 0 0) Reflection:false ReflectionAmount:(color 0 0 0) ReflectionMap:undefined Enabled:true Hide:false)
)
c_box.items = #()
update_slots current_top_slot
save_layer_in_helper layers_roll.layers_list.selection
)

on move_list_unsel pressed do
(
try
(
for j = 1 to c_box.items.count do
(
if j != c_box.selection then append s_m_material_array (s_m_material Node:c_box.items[j] opacity:false receiveShadows:false ShadowAlpha:false ShadowColor:(color 0 0 0) Reflection:false ReflectionAmount:(color 0 0 0) ReflectionMap:undefined Enabled:true Hide:false)
)
c_box.items = #(c_box.items[c_box.selection])
update_slots current_top_slot
save_layer_in_helper layers_roll.layers_list.selection
)
catch()
)

on get_unselected pressed do
(
max select invert
sel_array = selection as array
max select invert
for j = 1 to sel_array.count do
(
if finditem c_box.items sel_array[j].name != 0 then
	(
	append s_m_material_array (s_m_material Node:sel_array[j].name opacity:false receiveShadows:false ShadowAlpha:false ShadowColor:(color 0 0 0) Reflection:false ReflectionAmount:(color 0 0 0) ReflectionMap:undefined Enabled:true Hide:false)
	)

)
update_slots current_top_slot
save_layer_in_helper layers_roll.layers_list.selection
)

on get_scene_selected pressed do
(
sel_array = selection as array
for j = 1 to sel_array.count do
(
if finditem c_box.items sel_array[j].name != 0 then
	(
	append s_m_material_array (s_m_material Node:sel_array[j].name opacity:false receiveShadows:false ShadowAlpha:false ShadowColor:(color 0 0 0) Reflection:false ReflectionAmount:(color 0 0 0) ReflectionMap:undefined Enabled:true Hide:false)
	)

)
update_slots current_top_slot
save_layer_in_helper layers_roll.layers_list.selection
)



on clear_ms_list pressed do
(
s_m_material_array = #()
update_slots current_top_slot
save_layer_in_helper layers_roll.layers_list.selection
)

on select_all_ms pressed do
(
sel_array = #()
for m = 1 to s_m_material_array.count do
	(
	try
	(
	sel_node = execute ("$"+"'"+s_m_material_array[m].node+"'")
	append sel_array sel_node
	)catch()
	)
try(select sel_array)catch()
)


on select_all_visible pressed do
(
sel_array = #()
for m = 1 to c_box.items.count do
	(
	try
	(
	sel_node = execute ("$"+"'"+c_box.items[m]+"'")
	append sel_array sel_node
	)catch()
	)
try(select sel_array)catch()
)

)






fn update_slots c_t_s=

(

for j = 1 to 9 do

(

	try

	(

	text_value = s_m_material_array[j+c_t_s-1].node

	txt = "rl_roll.node_name_"+j as string+".text = \""+text_value+"\""

	execute txt

	read_val = s_m_material_array[j+c_t_s-1].opacity

	txt = "rl_roll.opac_alpha_"+j as string+".checked = "+ (read_val as string)

	execute txt

	read_val = s_m_material_array[j+c_t_s-1].ReceiveShadows

	txt = "rl_roll.rec_shadows_"+j as string+".checked = "+ (read_val as string)

	execute txt	

	read_val = s_m_material_array[j+c_t_s-1].ShadowAlpha

	txt = "rl_roll.shad_alpha_"+j as string+".checked = "+ (read_val as string)

	execute txt		

	read_val = s_m_material_array[j+c_t_s-1].ShadowColor

	txt = "rl_roll.shad_color_"+j as string+".color = "+ (read_val as string)

	execute txt	

	read_val = s_m_material_array[j+c_t_s-1].Reflection

	txt = "rl_roll.ref_toggle_"+j as string+".checked = "+ (read_val as string)

	execute txt	

	read_val = s_m_material_array[j+c_t_s-1].ReflectionAmount

	txt = "rl_roll.ref_amount_"+j as string+".color = "+ (read_val as string)

	execute txt	

--	read_val = s_m_material_array[j+c_t_s-1].ReflectionMap

--	txt = "rl_roll.ref_map_"+j as string+".map = "+ (read_val as string)

--	execute txt	

	read_val = s_m_material_array[j+c_t_s-1].Enabled

	txt = "rl_roll.onoff_toggle_"+j as string+".checked = "+ (read_val as string)

	execute txt	

	read_val = s_m_material_array[j+c_t_s-1].Hide

	txt = "rl_roll.hide_toggle_"+j as string+".checked = "+ (read_val as string)

	execute txt	

--	print "Set!"	

	)

	catch 

	(

--	print "Error!"

	txt = "rl_roll.node_name_"+j as string+".text = \" \""

	execute txt

	txt = "rl_roll.opac_alpha_"+j as string+".checked = false "

	execute txt

	txt = "rl_roll.rec_shadows_"+j as string+".checked = false "

	execute txt

	txt = "rl_roll.shad_alpha_"+j as string+".checked = false "

	execute txt	

	txt = "rl_roll.shad_color_"+j as string+".color = (color 0 0 0) "

	execute txt	

	txt = "rl_roll.ref_toggle_"+j as string+".checked = false "

	execute txt	

	txt = "rl_roll.ref_amount_"+j as string+".color = (color 0 0 0) "

	execute txt	

--	txt = "rl_roll.ref_map_"+j as string+".map = undefined "

--	execute txt	

	txt = "rl_roll.onoff_toggle_"+j as string+".checked = false "

	execute txt	

	txt = "rl_roll.hide_toggle_"+j as string+".checked = false "

	execute txt		

	)

	

)

save_layer_in_helper layers_roll.layers_list.selection

slots_array = #()

for j in s_m_material_array do

	(

	append slots_array j.node

	)

scene_objects = geometry as array

visible_array = #()

for s in scene_objects do

	(

	if findItem slots_array s.name == 0 then append visible_array s.name

	)

if rl_roll.alphabetical_vis.checked then sort visible_array

rl_roll.c_box.items = visible_array

)



fn ensure_valid_names =

(

nodes_array = geometry as array

test_string = " .-$![]{}"

for i in nodes_array do

(

new_name = i.name

for c = 1 to test_string.count do

(

str = substring test_string c 1

for j = 1 to new_name.count do

	(

	if substring new_name j 1 == str then 	

		(

		new_name = (substring new_name 1 (j-1)) + "_" + (substring new_name (j+1) (new_name.count-j) )

		)

	)

i.name = new_name	

)

)

)







ensure_valid_names ()	





if rl_nf != undefined then closerolloutfloater rl_nf

rl_nf = newrolloutfloater "RenderLayers v0.63" 430 500

addrollout layers_roll rl_nf  

addrollout gopt_roll rl_nf  rolledup:true

addrollout lopt_roll rl_nf  rolledup:true





helper_node = $RenderLayer_Helper



if helper_node != undefined then

	(

	ver_check = (getAppData helper_node (990622+1)) 

	if ver_check == undefined then ver_check = "RenderLayers Version 0.1"

	format "% %\n" "RL Helper Control String:" ver_check

	if  findstring ver_check "Version 0.2" != undefined or findstring ver_check "Version 0.3" != undefined or findstring ver_check "Version 0.4" != undefined or findstring ver_check "Version 0.5" != undefined or findstring ver_check "Version 0.6" != undefined then

		(

		layer_name_array = #()

		layer_number = (getAppData helper_node (990622)) as integer

		if layer_number > 0 then

			(

			for k = 1 to layer_number do

				(

				load_layer_from_helper k

				append layer_name_array s_m_layers_array[k].Name

				)

		

			layers_roll.layers_list.items = layer_name_array

			layers_roll.layers_list.selection  = 1

			load_layer_from_helper 1

			update_layer ()	

			format "%\n" "RenderLayers: Loading Data From Helper"

			)

		)

		else

		(

		format "%\n" "Outdated Version of RL Helper found and deleted." 

		unhide helper_node

		unfreeze helper_node

		delete helper_node

		helper_node = undefined

		)

	)



if helper_node == undefined then

	(

	helper_node = text text:"RenderLayerHelper" size:10 name:("RenderLayer_Helper")

	freeze helper_node	

	hide helper_node

	setAppData helper_node (990622) "0"

	setAppData helper_node (990622+1) ("RenderLayers Version 0.6")

	format "%\n" "RenderLayers: New RL Helper Created."

	)

	

format "%\n\n" "RenderLayers: Ready."	





)
